<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1">

    <!-- Google Font: Source Sans Pro -->
    <link rel="stylesheet"
        href="https://fonts.googleapis.com/css?family=Source+Sans+Pro:300,400,400i,700&display=fallback">
    <!-- Font Awesome -->
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/6.1.1/css/all.min.css">
    <!-- Theme style -->
    <link rel="stylesheet" href="dist/css/adminlte.min.css">

    <!-- bootstrap & jquery -->
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>

    <!-- SweetAlert2 -->
    <link rel="stylesheet" href="plugins/sweetalert2-theme-bootstrap-4/bootstrap-4.min.css">
    <script src="plugins/sweetalert2/sweetalert2.min.js"></script>

    <!-- Import Datatable sau jquery -->
    <!-- Import them style bootstrap cho datatable -->
    <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
    <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
    <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>
</head>

<body class="hold-transition sidebar-mini layout-fixed">
    <div class="wrapper">
        <!-- Navbar -->
        <nav class="main-header navbar navbar-expand navbar-white navbar-light">
            <!-- Left navbar links -->
            <ul class="navbar-nav">
                <li class="nav-item">
                    <a class="nav-link" data-widget="pushmenu" href="#" role="button"><i class="fas fa-bars"></i></a>
                </li>
                <li class="nav-item d-none d-sm-inline-block">
                    <a href="#" class="nav-link">Customer</a>
                </li>
            </ul>

            <!-- Right navbar links -->
            <ul class="navbar-nav ml-auto">
                <li class="nav-item dropdown mr-3">
                    <a class="nav-link" data-toggle="dropdown" href="#"><i class="fa-solid fa-user-large"></i></a>
                    <div class="dropdown-menu dropdown-menu-lg dropdown-menu-right">
                        <span class="dropdown-item dropdown-header" id="user-info"></span>
                        <div class="dropdown-divider"></div>
                        <div class="text-center mt-2">
                            <button class="btn btn-danger" id="btn-log-out"><i
                                    class="fa-solid fa-right-from-bracket"></i> Log out</button>
                        </div>
                    </div>
                </li>
            </ul>
        </nav>
        <!-- /.navbar -->

        <!-- Main Sidebar Container -->
        <aside class="main-sidebar sidebar-dark-primary elevation-4">
            <!-- Brand Logo -->
            <a href="addressMap.html" class="brand-link">
                <img src="dist/img/AdminLTELogo.png" alt="AdminLTE Logo" class="brand-image img-circle elevation-3"
                    style="opacity: .8">
                <span class="brand-text font-weight-light">ADMIN Real Estates</span>
            </a>

            <!-- Sidebar -->
            <div class="sidebar">
                <div class="user-panel mt-3 pb-3 mb-3 d-flex">
                    <div class="info text-white ml-2" id="username-info"></div>
                </div>
                <!-- Sidebar Menu -->
                <nav class="mt-2">
                    <ul class="nav nav-pills nav-sidebar flex-column" data-widget="treeview" role="menu"
                        data-accordion="false">
                        <!-- Add icons to the links using the .nav-icon class with font-awesome or any other icon font library -->
                        <li class="nav-item">
                            <a href="./addressMap.html" class="nav-link ">
                                <i class="fa-solid fa-map-location-dot"></i>
                                <p>
                                    Địa chỉ tọa độ
                                </p>
                            </a>
                        </li>
                        <li class="nav-item">
                            <a href="./masterLayout.html" class="nav-link">
                                <i class="fa-solid fa-layer-group"></i>
                                <p>
                                    Mặt bằng tầng
                                </p>
                            </a>
                        </li>
                        <li class="nav-item">
                            <a href="./constructionContractor.html" class="nav-link ">
                                <i class="fa-solid fa-person-digging"></i>
                                <p>
                                    Nhà thầu xây dựng
                                </p>
                            </a>
                        </li>
                        <li class="nav-item">
                            <a href="./designUnit.html" class="nav-link">
                                <i class="fa-solid fa-compass-drafting"></i>
                                <p>
                                    Đơn vị thiết kế
                                </p>
                            </a>
                        </li>
                        <li class="nav-item">
                            <a href="./investor.html" class="nav-link">
                                <i class="fa-solid fa-user-tie"></i>
                                <p>
                                    Nhà đầu tư
                                </p>
                            </a>
                        </li>
                        <li class="nav-item">
                            <a href="./regionLink.html" class="nav-link">
                                <i class="fa-solid fa-map"></i>
                                <p>
                                    Kết nối vùng
                                </p>
                            </a>
                        </li>
                        <li class="nav-item">
                            <a href="./utilities.html" class="nav-link">
                                <i class="fa-solid fa-person-swimming"></i>
                                <p>
                                    Tiện ích
                                </p>
                            </a>
                        </li>
                        <li class="nav-item">
                            <a href="./customers.html" class="nav-link active">
                                <i class="fa-solid fa-users-line"></i>
                                <p>
                                    Khách hàng
                                </p>
                            </a>
                        </li>
                        <li class="nav-item">
                            <a href="./employees.html" class="nav-link">
                                <i class="fa-solid fa-user"></i>
                                <p>
                                    Người dùng
                                </p>
                            </a>
                        </li>
                        <li class="nav-item">
                            <a href="./project.html" class="nav-link">
                                <i class="fa-solid fa-hotel"></i>
                                <p>
                                    Dự án xây dựng
                                </p>
                            </a>
                        </li>
                        <li class="nav-item">
                            <a href="./realestate.html" class="nav-link">
                                <i class="fa-solid fa-city"></i>
                                <p>
                                    Thông tin BĐS
                                </p>
                            </a>
                        </li>
                        <li class="nav-item">
                            <a href="#" class="nav-link">
                                <i class="fa-solid fa-bars"></i>
                                <p>
                                    Địa chính
                                    <i class="right fas fa-angle-left"></i>
                                </p>
                            </a>
                            <ul class="nav nav-treeview">
                                <li class="nav-item">
                                    <a href="./province.html" class="nav-link">
                                        <i class="fa-solid fa-tree-city"></i>
                                        <p>Tỉnh thành</p>
                                    </a>
                                </li>
                                <li class="nav-item">
                                    <a href="./district.html" class="nav-link">
                                        <i class="fa-solid fa-tree-city"></i>
                                        <p>Quận huyện</p>
                                    </a>
                                </li>
                                <li class="nav-item">
                                    <a href="./ward.html" class="nav-link">
                                        <i class="fa-solid fa-tree-city"></i>
                                        <p>Phường xã</p>
                                    </a>
                                </li>
                                <li class="nav-item">
                                    <a href="./street.html" class="nav-link">
                                        <i class="fa-solid fa-tree-city"></i>
                                        <p>Đường</p>
                                    </a>
                                </li>
                            </ul>
                        </li>
                        <li class="nav-item">
                            <a href="./subscription.html" class="nav-link">
                                <i class="fa-solid fa-bell"></i>
                                <p>
                                    Subscription
                                </p>
                            </a>
                        </li>
                    </ul>
                </nav>
                <!-- /.sidebar-menu -->
            </div>
            <!-- /.sidebar -->
        </aside>

        <!-- Content Wrapper. Contains page content -->
        <div class="content-wrapper">
            <!-- Content Header (Page header) -->
            <div class="content-header">
                <div class="container-fluid">
                    <div class="row mb-2">
                        <div class="col-sm-6">
                        </div><!-- /.col -->
                        <div class="col-sm-6">
                            <ol class="breadcrumb float-sm-right">
                                <li class="breadcrumb-item"><a href="#">Home</a></li>
                                <li class="breadcrumb-item active">Customer</li>
                            </ol>
                        </div><!-- /.col -->
                    </div><!-- /.row -->
                </div><!-- /.container-fluid -->
            </div>
            <!-- /.content-header -->

            <!-- Main content -->
            <section class="content">
                <div class="container-fluid">
                    <h4 class="text-center form-group">Customer List</h4>
                    <div class="form-group">
                        <button class="btn btn-success" id="btn-create-new-customer"><i class="fa-solid fa-plus"></i>
                            Create New Customer</button>
                    </div>
                    <table class="table table-bordered table-striped table-hover" id="customer-table">
                        <thead>
                            <tr>
                                <th>ID</th>
                                <th>Contact Name</th>
                                <th>Contact Title</th>
                                <th>Address</th>
                                <th>Mobile</th>
                                <th>Email</th>
                                <th>Note</th>
                                <th>Action</th>
                            </tr>
                        </thead>
                        <tbody>
                        </tbody>
                    </table>

                </div><!-- /.container-fluid -->
            </section>
            <!-- /.content -->

            <!-- Create new customer modal -->
            <div id="create-customer-modal" class="modal fade" tabindex="-1">
                <div class="modal-dialog">
                    <div class="modal-content">
                        <div class="modal-header bg-success">
                            <h5 class="modal-title">Create New Customer</h5>
                            <button class="close" data-dismiss="modal">&times;</button>
                        </div>
                        <div class="modal-body">
                            <form>
                                <div class="row form-group">
                                    <div class="col-md-4 text-left">
                                        <label>Contact Name</label>
                                    </div>
                                    <div class="col-md-8 form-group">
                                        <input id="create-input-name" type="text" class="form-control">
                                    </div>
                                </div>
                                <div class="row form-group">
                                    <div class="col-md-4 text-left">
                                        <label>Contact Title</label>
                                    </div>
                                    <div class="col-md-8 form-group">
                                        <input id="create-input-title" type="text" class="form-control">
                                    </div>
                                </div>
                                <div class="row form-group">
                                    <div class="col-md-4 text-left">
                                        <label>Address</label>
                                    </div>
                                    <div class="col-md-8 form-group">
                                        <input id="create-input-address" type="text" class="form-control">
                                    </div>
                                </div>
                                <div class="row form-group">
                                    <div class="col-md-4 text-left">
                                        <label>Mobile</label>
                                    </div>
                                    <div class="col-md-8 form-group">
                                        <input id="create-input-mobile" type="text" class="form-control">
                                    </div>
                                </div>
                                <div class="row form-group">
                                    <div class="col-md-4 text-left">
                                        <label>Email</label>
                                    </div>
                                    <div class="col-md-8 form-group">
                                        <input id="create-input-email" type="text" class="form-control">
                                    </div>
                                </div>
                                <div class="row form-group">
                                    <div class="col-md-4 text-left">
                                        <label>Note</label>
                                    </div>
                                    <div class="col-md-8 form-group">
                                        <input id="create-input-note" type="text" class="form-control">
                                    </div>
                                </div>
                                <div class="row form-group">
                                    <div class="col-md-4 text-left">
                                        <label>Create by</label>
                                    </div>
                                    <div class="col-md-8 form-group">
                                        <input id="create-input-createBy" type="number" class="form-control">
                                    </div>
                                </div>
                                <div class="row form-group">
                                    <div class="col-md-4 text-left">
                                        <label>Update By</label>
                                    </div>
                                    <div class="col-md-8 form-group">
                                        <input id="create-input-updateBy" type="number" class="form-control">
                                    </div>
                                </div>
                            </form>
                        </div>
                        <div class="modal-footer">
                            <button class="btn btn-primary" id="btn-create-confirm">Confirm</button>
                            <button class="btn btn-secondary" id="btn-create-cancel"
                                data-dismiss="modal">Cancel</button>
                        </div>
                    </div>
                </div>
            </div>

            <!-- customer Detail modal -->
            <div id="customer-detail-modal" class="modal fade" tabindex="-1">
                <div class="modal-dialog">
                    <div class="modal-content">
                        <div class="modal-header bg-success">
                            <h5 class="modal-title">Customer Details</h5>
                            <button class="close" data-dismiss="modal">&times;</button>
                        </div>
                        <div class="modal-body">
                            <form>
                                <div class="row form-group">
                                    <div class="col-md-4 text-left">
                                        <label>Contact Name</label>
                                    </div>
                                    <div class="col-md-8 form-group">
                                        <input id="update-input-name" type="text" class="form-control">
                                    </div>
                                </div>
                                <div class="row form-group">
                                    <div class="col-md-4 text-left">
                                        <label>Contact Title</label>
                                    </div>
                                    <div class="col-md-8 form-group">
                                        <input id="update-input-title" type="text" class="form-control">
                                    </div>
                                </div>
                                <div class="row form-group">
                                    <div class="col-md-4 text-left">
                                        <label>Address</label>
                                    </div>
                                    <div class="col-md-8 form-group">
                                        <input id="update-input-address" type="text" class="form-control">
                                    </div>
                                </div>
                                <div class="row form-group">
                                    <div class="col-md-4 text-left">
                                        <label>Mobile</label>
                                    </div>
                                    <div class="col-md-8 form-group">
                                        <input id="update-input-mobile" type="text" class="form-control">
                                    </div>
                                </div>
                                <div class="row form-group">
                                    <div class="col-md-4 text-left">
                                        <label>Email</label>
                                    </div>
                                    <div class="col-md-8 form-group">
                                        <input id="update-input-email" type="text" class="form-control">
                                    </div>
                                </div>
                                <div class="row form-group">
                                    <div class="col-md-4 text-left">
                                        <label>Note</label>
                                    </div>
                                    <div class="col-md-8 form-group">
                                        <input id="update-input-note" type="text" class="form-control">
                                    </div>
                                </div>
                                <div class="row form-group">
                                    <div class="col-md-4 text-left">
                                        <label>Create by</label>
                                    </div>
                                    <div class="col-md-8 form-group">
                                        <input id="update-input-createBy" type="number" class="form-control">
                                    </div>
                                </div>
                                <div class="row form-group">
                                    <div class="col-md-4 text-left">
                                        <label>Update By</label>
                                    </div>
                                    <div class="col-md-8 form-group">
                                        <input id="update-input-updateBy" type="number" class="form-control">
                                    </div>
                                </div>
                            </form>
                        </div>
                        <div class="modal-footer">
                            <button class="btn btn-primary" id="btn-update-confirm">Update Confirm</button>
                            <button class="btn btn-secondary" id="btn-update-cancel"
                                data-dismiss="modal">Cancel</button>
                        </div>
                    </div>
                </div>
            </div>

            <!-- Delete customer modal -->
            <div id="delete-customer-modal" class="modal fade" tabindex="-1">
                <div class="modal-dialog">
                    <div class="modal-content">
                        <div class="modal-header bg-danger">
                            <h5 class="modal-title">Delete Customer Confirmation</h5>
                            <button class="close" data-dismiss="modal">&times;</button>
                        </div>
                        <div class="modal-body">
                            Are you sure to delete this Customer?
                        </div>
                        <div class="modal-footer">
                            <button class="btn btn-danger" id="btn-delete-confirm">Confirm</button>
                            <button class="btn btn-secondary" id="btn-update-cancel"
                                data-dismiss="modal">Cancel</button>
                        </div>
                    </div>
                </div>
            </div>

        </div>
        <!-- /.content-wrapper -->
        <footer class="main-footer">
            <strong>Copyright &copy; 2014-2021 Devcamp.</strong>
            All rights reserved.
            <div class="float-right d-none d-sm-inline-block">
                <b>Version</b> 1.0.0
            </div>
        </footer>
    </div>

    <!-- AdminLTE App -->
    <script src="dist/js/adminlte.js"></script>

    <script>
        $(document).ready(function () {

            const token = getCookie("token");

            // Biến mảng toàn cục chứa danh sách tên các thuộc tính
            const gDATA_COLS = ["id", "contactName", "contactTitle", "address", "mobile", "email", "note", "action"];

            // Biến mảng toàn cục định nghĩa chỉ số các cột tương ứng
            const gID_COL = 0;
            const gNAME_COL = 1;
            const gTITLE_COL = 2;
            const gADDRESS_COL = 3;
            const gMOBILE_COL = 4;
            const gEMAIL_COL = 5;
            const gNOTE_COL = 6;
            const gACTION_COL = 7;

            var gTable = $("#customer-table").DataTable({
                columns: [
                    { data: gDATA_COLS[gID_COL] },
                    { data: gDATA_COLS[gNAME_COL] },
                    { data: gDATA_COLS[gTITLE_COL] },
                    { data: gDATA_COLS[gADDRESS_COL] },
                    { data: gDATA_COLS[gMOBILE_COL] },
                    { data: gDATA_COLS[gEMAIL_COL] },
                    { data: gDATA_COLS[gNOTE_COL] },
                    { data: gDATA_COLS[gACTION_COL] },
                ],
                "columnDefs": [
                    {
                        "targets": gACTION_COL,
                        "defaultContent": `<button class='btn btn-primary btn-detail-customer'><i class="fa-regular fa-pen-to-square"></i></button>
    <button class='btn btn-danger btn-delete-customer'><i class="fa-regular fa-trash-can"></i></button>`
                    }],
            });

            var gId;

            /*** REGION 2 - Vùng gán / thực thi hàm xử lý sự kiện cho các elements */
            onPageLoading();

            //Set sự kiện cho nút logout
            $("#btn-log-out").on("click", function () {
                redirectToLogin();
            });

            // gán xự kiện nút tạo mới customer
            $("#btn-create-new-customer").on("click", function () {
                $("#create-customer-modal").modal("show");
            });

            // gán xự kiện  nút chi tiết customer
            $("#customer-table").on("click", ".btn-detail-customer", function () {
                onBtnDetailCustomerClick(this);
            });

            // gán xự kiện  nút xóa customer
            $("#customer-table").on("click", ".btn-delete-customer", function () {
                onBtnDeleteCustomerClick(this);
            });

            // gán xự kiện nút xác nhận tạo mới customer
            $("#btn-create-confirm").on("click", function () {
                onBtnCreateCustomerConfirmClick();
            });

            // gán xự kiện nút xác nhận câp nhật customer
            $("#btn-update-confirm").on("click", function () {
                onBtnUpdateCustomerConfirmClick();
            });

            // gán xự kiện  nút xác nhận xóa customer
            $("#btn-delete-confirm").on("click", function () {
                onBtnDeleteCustomerConfirmClick();
            });

            /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
            function onPageLoading() {
                "use strict";
                callApiGetUserIdByToken();
                callApiGetAllCustomer();
            }

            // Hàm xử lý khi nút xác nhận tạo mới customer được nhấn
            function onBtnCreateCustomerConfirmClick() {
                "use strict";
                var vCreateData = {
                    contactName: "",
                    contactTitle: "",
                    address: "",
                    mobile: "",
                    email: "",
                    note: "",
                    createBy: "",
                    updateBy: "",
                }
                // B1: Thu thập dữ liệu
                getCreateData(vCreateData);
                // B2: Kiểm tra dữ liệu
                var isValidate = validateCreateData(vCreateData);
                if (isValidate == true) {
                    // B3: xử lý hiển thị dữ liệu
                    callApiCreateNewCustomer(vCreateData);
                    // gọi lại tất cả customer
                    callApiGetAllCustomer();
                    // Ẩn modal
                    $("#create-customer-modal").modal("hide");
                    // clear dữ liệu trên modal
                    clearDataInCreateModal();
                }
            }

            // Hàm xử lý khi nút chi tiết customer được nhấn
            function onBtnDetailCustomerClick(paramBtnDetail) {
                "use strict";
                // B1: Thu thập dữ liệu
                //Xác định thẻ tr là cha của nút được chọn
                var vRowSelected = $(paramBtnDetail).parents('tr');
                // Lấy các dữ liệu của hàng có cùng hàng với nút được nhấn
                var vDataRow = gTable.row(vRowSelected).data();
                //console.log(vDataRow);
                gId = vDataRow.id;
                // B2: Kiểm tra dữ liệu (bỏ qua)
                // B3: xử lý hiển thị dữ liệu vào modal
                callApiGetCustomerDataById();
                // Hiện modal
                $("#customer-detail-modal").modal("show");
            }

            // Hàm xử lý khi nút chi tiết customer được nhấn
            function onBtnDeleteCustomerClick(paramBtnDetail) {
                "use strict";
                // B1: Thu thập dữ liệu
                //Xác định thẻ tr là cha của nút được chọn
                var vRowSelected = $(paramBtnDetail).parents('tr');
                // Lấy các dữ liệu của hàng có cùng hàng với nút được nhấn
                var vDataRow = gTable.row(vRowSelected).data();
                gId = vDataRow.id;
                // B2: Kiểm tra dữ liệu (bỏ qua)
                // B3: xử lý hiển thị dữ liệu vào modal
                // Hiện modal
                $("#delete-customer-modal").modal("show");
            }

            // Hàm xử lý khi nút xác nhận cập nhật customer được nhấn
            function onBtnUpdateCustomerConfirmClick() {
                "use strict";
                var vUpdateData = {
                    contactName: "",
                    contactTitle: "",
                    address: "",
                    mobile: "",
                    email: "",
                    note: "",
                    createBy: "",
                    updateBy: "",
                }
                // B1: Thu thập dữ liệu
                getUpdateData(vUpdateData);
                // B2: Kiểm tra dữ liệu
                var isValidate = validateUpdateData(vUpdateData);
                if (isValidate == true) {
                    // B3: xử lý hiển thị dữ liệu
                    callApiUpdateCustomer(vUpdateData);
                    // gọi lại tất cả customers
                    callApiGetAllCustomer();
                    // Ẩn modal
                    $("#customer-detail-modal").modal("hide");
                }
            }

            // Hàm xử lý khi nút xác nhận xóa customer được nhấn
            function onBtnDeleteCustomerConfirmClick() {
                "use strict";
                // B1: Thu thập dữ liệu (bỏ qua)
                // B2: Kiểm tra dữ liệu (bỏ qua)
                // B3: xử lý hiển thị dữ liệu
                callApiDeleteCustomer();
                // gọi lại tất cả customers
                callApiGetAllCustomer();
                // Ẩn modal
                $("#delete-customer-modal").modal("hide");
            }

            /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình */
            // Hàm load dữ liệu vào bảng
            function loadDataToTable(paramData) {
                "use strict";
                //Xóa toàn bộ dữ liệu đang có của bảng
                gTable.clear();
                //Cập nhật data cho bảng
                gTable.rows.add(paramData);
                //Cập nhật lại giao diện hiển thị bảng
                gTable.draw();
            }

            function callApiGetUserIdByToken() {
                $.ajax({
                    url: "http://localhost:8080/findUserId/Token",
                    type: 'GET',
                    dataType: "json",
                    contentType: "application/json; charset=utf-8",
                    headers: {
                        "Authorization": "Token " + token,
                    },
                    success: function (responseObject) {
                        //console.log(responseObject);
                        callApiGetEmployeeByID(responseObject);
                    },
                    error: function (pAjaxContext) {
                        //redirectToLogin();
                    }
                });
            }

            // Hàm gọi api lấy dữ liệu employee bằng id
            function callApiGetEmployeeByID(paramEmployeeId) {
                $.ajax({
                    url: "http://localhost:8080/employees/" + paramEmployeeId,
                    method: "GET",
                    async: false,
                    success: function (paramResponseObj) {
                        console.log(paramResponseObj);
                        handlerUserDataResponse(paramResponseObj);
                    },
                    error: function (paramError) {
                        console.log(paramError);
                    }
                });
            }

            function handlerUserDataResponse(paramUserData) {
                $("#username-info").html(paramUserData.username);
                $("#user-info").html(paramUserData.username);
            }

            // Hàm gọi api lấy tất cả customer
            function callApiGetAllCustomer() {
                $.ajax({
                    url: "http://localhost:8080/customers",
                    method: "GET",
                    headers: {
                        'Content-Type': 'application/json;charset=UTF-8',
                        "Authorization": "Token " + token,
                    },
                    success: function (paramResponseObj) {
                        //console.log(paramResponseObj);
                        loadDataToTable(paramResponseObj);
                    },
                    error: function (paramError) {
                        console.log(paramError);
                    }
                });
            }

            // Hàm gọi api lấy dữ liệu customer bằng id
            function callApiGetCustomerDataById() {
                $.ajax({
                    url: "http://localhost:8080/customers/" + gId,
                    method: "GET",
                    async: false,
                    headers: {
                        'Content-Type': 'application/json;charset=UTF-8',
                        "Authorization": "Token " + token,
                    },
                    success: function (paramResponseObj) {
                        //console.log(paramResponseObj);
                        loadDataOnDetailModal(paramResponseObj);

                    },
                    error: function (paramError) {
                        console.log(paramError);
                    }
                });
            }

            // Hàm gọi api tạo customer
            function callApiCreateNewCustomer(paramCreateData) {
                $.ajax({
                    url: "http://localhost:8080/customers",
                    method: "POST",
                    async: false,
                    contentType: "application/json;charset=UTF-8",
                    data: JSON.stringify(paramCreateData),
                    headers: {
                        'Content-Type': 'application/json;charset=UTF-8',
                        "Authorization": "Token " + token,
                    },
                    success: function (paramResponseObj) {
                        //console.log(paramResponseObj);
                        alertSuccess("Success.");
                    },
                    error: function (paramError) {
                        console.log(paramError);
                        alertError("Failed.");
                    }
                });
            }

            // Hàm gọi api cập nhật customer
            function callApiUpdateCustomer(paramUpdateData) {
                $.ajax({
                    url: "http://localhost:8080/customers/" + gId,
                    method: "PUT",
                    async: false,
                    contentType: "application/json;charset=UTF-8",
                    data: JSON.stringify(paramUpdateData),
                    headers: {
                        'Content-Type': 'application/json;charset=UTF-8',
                        "Authorization": "Token " + token,
                    },
                    success: function (paramResponseObj) {
                        //console.log(paramResponseObj);
                        alertSuccess("Success.");
                    },
                    error: function (paramError) {
                        console.log(paramError);
                        alertError("Failed.");
                    }
                });
            }

            // Hàm gọi api xóa customer
            function callApiDeleteCustomer() {
                $.ajax({
                    url: "http://localhost:8080/customers/" + gId,
                    method: "DELETE",
                    async: false,
                    headers: {
                        'Content-Type': 'application/json;charset=UTF-8',
                        "Authorization": "Token " + token,
                    },
                    success: function (paramResponseObj) {
                        //console.log(paramResponseObj);
                        alertSuccess("Success.");
                    },
                    error: function (paramError) {
                        console.log(paramError);
                        alertError("Failed.");
                    }
                });
            }

            // Hàm thu thập dữ liệu để tạo customer
            function getCreateData(paramCreateData) {
                "use strict";
                paramCreateData.contactName = $("#create-input-name").val().trim();
                paramCreateData.contactTitle = $("#create-input-title").val().trim();
                paramCreateData.address = $("#create-input-address").val().trim();
                paramCreateData.mobile = $("#create-input-mobile").val().trim();
                paramCreateData.email = $("#create-input-email").val().trim();
                paramCreateData.note = $("#create-input-note").val().trim();
                paramCreateData.createBy = $("#create-input-createBy").val().trim();
                paramCreateData.updateBy = $("#create-input-updateBy").val().trim();
            }

            // Hàm thu thập dữ liệu để cap nhat customer
            function getUpdateData(paramUpdateData) {
                "use strict";
                paramUpdateData.contactName = $("#update-input-name").val().trim();
                paramUpdateData.contactTitle = $("#update-input-title").val().trim();
                paramUpdateData.address = $("#update-input-address").val().trim();
                paramUpdateData.mobile = $("#update-input-mobile").val().trim();
                paramUpdateData.email = $("#update-input-email").val().trim();
                paramUpdateData.note = $("#update-input-note").val().trim();
                paramUpdateData.createBy = $("#update-input-createBy").val().trim();
                paramUpdateData.updateBy = $("#update-input-updateBy").val().trim();
            }

            // Hàm kiểm tra dữ liệu để tạo customer
            function validateCreateData(paramCreateData) {
                "use strict";
                if (paramCreateData.name == "") {
                    alertError("Contact Name không được để trống");
                    return false;
                }
                if (paramCreateData.mobile == "") {
                    alertError("Mobile không được để trống");
                    return false;
                }
                if (paramCreateData.email == "") {
                    alertError("Email không được để trống");
                    return false;
                }
                return true;
            }

            // Hàm kiểm tra dữ liệu để cap nhat customer
            function validateUpdateData(paramUpdateData) {
                "use strict";
                if (paramUpdateData.name == "") {
                    alertError("Name không được để trống");
                    return false;
                }
                if (paramUpdateData.mobile == "") {
                    alertError("Mobile không được để trống");
                    return false;
                }
                if (paramUpdateData.email == "") {
                    alertError("Email không được để trống");
                    return false;
                }
                return true;
            }

            // Xóa trắng dữ liệu trong form create modal
            function clearDataInCreateModal() {
                $("#create-input-name").val("");
                $("#create-input-title").val("");
                $("#create-input-address").val("");
                $("#create-input-mobile").val("");
                $("#create-input-email").val("");
                $("#create-input-note").val("");
                $("#create-input-createBy").val("");
                $("#create-input-updateBy").val("");
            }

            // load dữ liệu vào form trên detail modal
            function loadDataOnDetailModal(paramRowData) {
                $("#update-input-name").val(paramRowData.contactName);
                $("#update-input-title").val(paramRowData.contactTitle);
                $("#update-input-address").val(paramRowData.address);
                $("#update-input-mobile").val(paramRowData.mobile);
                $("#update-input-email").val(paramRowData.email);
                $("#update-input-note").val(paramRowData.note);
                $("#update-input-createBy").val(paramRowData.createBy);
                $("#update-input-updateBy").val(paramRowData.updateBy);
            }

            function redirectToLogin() {
                // Trước khi logout cần xóa token đã lưu trong cookie
                setCookie("token", "", 1);
                window.location.href = "index.html";
            }

            //Hàm get Cookie
            function getCookie(cname) {
                var name = cname + "=";
                var decodedCookie = decodeURIComponent(document.cookie);
                var ca = decodedCookie.split(';');
                for (var i = 0; i < ca.length; i++) {
                    var c = ca[i];
                    while (c.charAt(0) == ' ') {
                        c = c.substring(1);
                    }
                    if (c.indexOf(name) == 0) {
                        return c.substring(name.length, c.length);
                    }
                }
                return "";
            }

            //Hàm setCookie đã giới thiệu ở bài trước
            function setCookie(cname, cvalue, exdays) {
                var d = new Date();
                d.setTime(d.getTime() + (exdays * 24 * 60 * 60 * 1000));
                var expires = "expires=" + d.toUTCString();
                document.cookie = cname + "=" + cvalue + ";" + expires + ";path=/";
            }

            // Hàm alert success
            function alertSuccess(paramTitle) {
                "use strict";
                $(function () {
                    var Toast = Swal.mixin({
                        toast: false,
                        position: 'top',
                        showConfirmButton: false,
                        timer: 3500
                    });
                    Toast.fire({
                        icon: 'success',
                        title: paramTitle,
                    })
                });
            }

            // Hàm alert lỗi
            function alertError(paramTitle) {
                "use strict";
                $(function () {
                    var Toast = Swal.mixin({
                        toast: false,
                        position: 'top',
                        showConfirmButton: false,
                        timer: 3500
                    });
                    Toast.fire({
                        icon: 'error',
                        title: paramTitle,
                    })
                });
            }

        });

    </script>
</body>